#include <funkce.h>
#define CLOCK_1MHZ
//#define CLOCK_2MHZ

void bus_init(void)                           // nastaveni sbernice - DA0-DA7, BDIR, BC2
{
  puts("Inicializace BUS....");
  // aktivace hodin portu C a reset
  if (!(RCC->AHB1ENR & RCC_AHB1ENR_GPIOCEN))  // kontrola aktivace hodin hodin portu C
  {
    RCC->AHB1ENR |= RCC_AHB1ENR_GPIOCEN;      // povoleni hodiny periferie
    RCC->AHB1RSTR |= RCC_AHB1RSTR_GPIOCRST;   // proved reset periferie
    RCC->AHB1RSTR &= ~RCC_AHB1RSTR_GPIOCRST;  // a konec resetu
  }

  // nastaveni konfiguracnich bitu do defaultniho stavu (nemususelo byt od drive)
  // 0x000F_FFFF = 0000 0000 1111 1111 1111 1111 1111
  GPIOC->MODER &= ~(0x000FFFFF);              // vynuluje  bity v registru,
  GPIOC->PUPDR &= ~(0x000FFFFF);              // vynuluje  bity v registru
  GPIOC->OSPEEDR &= ~(0x000FFFFF);            // vynuluje  bity v registru

  // nastaveni pinu na portu C
  //0x055_5555 = 0000 0101 0101 0101 0101 0101 0101
  //0x000F_FFFF = 0000 0000 1111 1111 1111 1111 1111
  //0x03FF = 0000 0011 1111 1111
  GPIOC->MODER |= 0x0055555;                  // 01 = vystupni orientace pinu
  GPIOC->OSPEEDR |= 0x000FFFFF;               // 11 = high speed (rychlost zmen na pinech)
  GPIOC->PUPDR &= ~(0x000FFFFF);              // 00 = vypnute pull-up/pull-down rezistory
  GPIOC->OTYPER &= ~(0x03FF);                 // 0 = push-pull vystup

  puts("OK\n");
}
void reset_init(void)                         // nastaveni reset tlacitka na pinu PC_13
{
  puts("\nInicializace RESETu....");
  // aktivace hodin portu C a reset
  if (!(RCC->AHB1ENR & RCC_AHB1ENR_GPIOCEN))   // kontrola aktivace hodin hodin portu C
  {
    RCC->AHB1ENR |= RCC_AHB1ENR_GPIOCEN;       // povolit hodiny periferie
    RCC->AHB1RSTR |= RCC_AHB1RSTR_GPIOCRST;    // proved reset periferie
    RCC->AHB1RSTR &= ~RCC_AHB1RSTR_GPIOCRST;   // a konec resetu
  }

  // nastaveni konfiguracnich bitu do defaultniho stavu (nemususelo byt od drive)
  // 0x0C00_0000 = 1100 0000 0000 0000 0000 0000 0000
  GPIOC->MODER &= ~(0x0C000000);              // vynuluj bity v registru,
  GPIOC->PUPDR &= ~(0x0C000000);              // vynuluj bity v registru
  GPIOC->OSPEEDR &= ~(0x0C000000);            // vynuluj bity v registru

  // prvotni reset na nastaveni resetovaciho tlacitka na pinu PC_13
  GPIOC->BSRR |= PC_13_RESET;                   // nastaveni reset casti do 1 -> PC13 = 0 -> reset AY-891x (je aktivni na log. 0)
  GPIOC->BSRR |= PC_13_SET;                   // nastaveni set casti do 1 -> PC13 = 1 (set ma vyssi prioritu ne reset)
  puts("OK\n");
}
bool read_reset_btn(void)                     // cteni hodnoty reset tlacika
{
  //puts("Cteni stavu tlacitka RESET");
  return ((GPIOC->IDR & (1 << 13)) != 0);     // defaultni stav IDR_13 = 1 (nezmacknute tlacitko) -> 1 != 0 -> true
  // zmacknute tlacitko IDR_13 = 0 -> 0 != 0 -> false
  //puts("Cteni stavu dokonceno");
}
void clock_init(void)                         // nastaveni citace pro generovani 1 MHz hodinoveho signalu
{
  puts("Inicializace CLK....");

  // povoleni hodin k casovaci TIM5_CH1 PA0
  if (!(RCC->APB1ENR & RCC_APB1ENR_TIM5EN))   // kontrola aktivace hodin k casovaci
  {
    RCC->APB1ENR |= RCC_APB1ENR_TIM5EN;       // povoleni hodiny periferie
    RCC->APB1RSTR |= RCC_APB1RSTR_TIM5RST;    // proved reset periferie
    RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM5RST;   // a konec resetu
  }

  // aktivace hodin portu A a reset
  if (!(RCC->AHB1ENR & RCC_AHB1ENR_GPIOAEN))  // kontrola aktivace hodin hodin portu A
  {
    RCC->AHB1ENR |= RCC_AHB1ENR_GPIOAEN;      // povolit hodiny periferie
    RCC->AHB1RSTR |= RCC_AHB1RSTR_GPIOARST;   // proved reset periferie
    RCC->AHB1RSTR &= ~RCC_AHB1RSTR_GPIOARST;  // a konec resetu
  }

  // nastaveni konfiguracnich bitu do defaultniho stavu (nemususelo byt od drive)
  // 0x03 =  0011
  GPIOA->MODER &= ~(0x03);                    // vynuluj bity v registru
  GPIOA->PUPDR &= ~(0x03);                    // vynuluj bity v registru
  GPIOA->OSPEEDR &= ~(0x03);                  // vynuluj bity v registru

  // 0x02 = 0010
  // 0x01 = 0001
  GPIOA->MODER |= 0x02;                       // 10 = alternativni fuknce pinu PA_0
  GPIOA->OTYPER &= ~(0x01);                   // 0 = push-pull vystup
  GPIOA->OSPEEDR |= 0x03;                     // 11 = high speed (rychlost zmen na pinu)
  GPIOA->PUPDR &= ~(0x03);                    // 00 = vypnute pull-up/pull-down rezistory

  // 0x000F = 0000 0000 0000 1111
  // 0x0002 = 0000 0000 0000 0010
  GPIOA->AFR[0] &= ~(0x000F);                 // vynulovani registru AFR_L
  GPIOA->AFR[0] |= 0x0002;                    // 0010 = nastav alternativni fuknci AF2 na pinu PA_0

  TIM5->CR1 = TIM_CR1_ARPE;                   // DIR = 0 -> citac nahoru, bufferovany zapis do ARR
  TIM5->CR2 = 0;                              // nic nenastavujeme


#ifdef CLOCK_1MHZ
  TIM5->PSC = 8 - 1;                          // 16 MHz / 8 = 2 MHz (0.5 us) -> rychlost citani (jednoho kroku) citace
  TIM5->ARR = 2 - 1;                          // maximalni hodnota citace
#endif

#ifdef CLOCK_2MHZ
  TIM5->PSC = 4 - 1;                          // 16 MHz / 4 = 4 MHz (0.25 us) -> rychlost citani (jednoho kroku) citace
  TIM5->ARR = 2 - 1;                          // maximalni hodnota citace
#endif

  TIM5->CCMR1 &= ~TIM_CCMR1_OC1M;             // vynulovani OC3m
  TIM5->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;   // 110 = PWM mode 1
  TIM5->CCER |= TIM_CCER_CC1E;                // povoleni vystupu OC1 na pin PA_0
  TIM5->CCR1 = 1;                 //  1 ->  strida 50%

  TIM5->CR1 = TIM_CR1_CEN;                    // aktivace citace (Counter Enable), posledn akce

  puts("OK\n");
}
void bus_inactive(void)                       // nastaveni sbernice do neaktivniho stavu
{
  GPIOC->BSRR |= (BDIR_RESET | BC1_RESET);    // reset pinu  BDIR = 0, BC1 = 0
  //puts("BUS je neaktivni");
}
void bus_write(void)                          //priprav sbernici pro zapis hodnoty do registru
{
  GPIOC->BSRR |= BDIR_SET;                    // nastavi BDIR = 1
  //puts("BUS je v rezimu zapisu do registru");
}
void bus_latch_adress(void)                   // priprav sbernici pro vyber registru
{
  GPIOC->BSRR |= (BC1_SET | BDIR_SET);        // nastavi BDIR = 1, BC1 = 1
  //puts("BUS je v rezimu vyberu registru");
}
void bus_reset(void)                          // nastavi DA0 -DA7 na nulu
{
  GPIOC->BSRR |= (DA0_DA7_RESET);             // reset pinu DA0 - DA7 = 0
  //puts("DA_0 az DA_7 jsou resetovany");
}
void zapis_do_registru(uint8_t registr, uint8_t hodnota) // vyber a zapis hodnoty do registru
{
  if((registr >=0) && (registr <= 13)) // omezeni cisla registru na max. 15 kvuli hornim 4 bitum sbernice ktere musi byt pri vyberu registru na nule
  {
    //puts("Vyber registru");

    bus_latch_adress();                         // priprav sbernici pro vyber registru

    GPIOC->BSRR = registr;
    //puts("Registr vybran");

    bus_inactive();                             // nastaveni sbernice do neaktivniho stavu

    bus_reset();                                // nastavi DA0 -DA7 na nulu

    //puts("\nZapis dat do registru");
    GPIOC->BSRR = hodnota;
    //puts("Data pro zapis jsou na BUS");

    bus_write();                                //priprav sbernici pro zapis hodnoty do registru
    //puts("Data zapsana do registru");

    bus_inactive();                             // nastaveni sbernice do neaktivniho stavu

    bus_reset();                                // nastavi DA0 -DA7 na nulu

    //puts("Vyber a ulozeni dokonceno\n");
  }
}

void vyber_kanalu_tonu_noise(kanaly_ton channel, noise povolit_noise)
{
  uint8_t x = 0xFF;               // promenna pomoci ktere se bude vybirat kanal, default stav je vsechny kanaly vypnute

  {
    switch(channel)               // vyber kanalu, nastaveni spodnich trech bitu
    {
      case CHANNEL_TONE_NONE:     // vsechny kanaly vypnute
        zapis_do_registru(ENABLE_NOISE_TONE, 0xFF);
        break;

      case CHANNEL_TONE_A:        // zapnout kanal A
        x &= ~(1 << 0);           // nastaveni nuly na danou pozici
        puts("Vybran kanal A");   // vypis na seriovy kanal pomoci USARTu
        break;

      case CHANNEL_TONE_B:        // zapnout kanal B
        x &= ~(1 << 1);           // nastaveni nuly na danou pozici
        puts("Vybran kanal B");
        break;

      case CHANNEL_TONE_C:        // zapnout kanal C
        x &= ~(1 << 2);           // nastaveni nuly na danou pozici
        puts("Vybran kanal C");
        break;

      case CHANNEL_TONE_AB:        // zapnout kanal A, B
        x &= ~((1 << 0) | (1 << 1));
        puts("Vybran kanal A, B");
        break;

      case CHANNEL_TONE_AC:        // zapnout kanal A, C
        x &= ~((1 << 0) | (1 << 2));
        puts("Vybran kanal A, C");
        break;

      case CHANNEL_TONE_BC:        // zapnout kanal B, C
        x &= ~((1 << 1) | (1 << 2));
        puts("Vybran kanal B, C");
        break;

      case CHANNEL_TONE_ABC:        // zapnout kanal A, B, C
        x &= ~((1 << 0) | (1 << 1) | (1 << 2));
        puts("Vybran kanal A, B, C");
        break;
    }

    if(povolit_noise)               // povoleni generatoru sumu na danem kanalu, nastaveni hornich trech bitu
    {
      switch(channel)
      {
        case CHANNEL_TONE_NONE:     // neni povolen generator sum
          break;

        case CHANNEL_NOISE_A:       // generator sumu na kanalu A
          x &= ~(1 << 3);           // nastaveni nuly na danou pozici
          break;

        case CHANNEL_NOISE_B:       // generator sumu na kanalu B
          x &= ~(1 << 4);
          break;

        case CHANNEL_NOISE_C:       // generator sumu na kanalu C
          x &= ~(1 << 5);
          break;

        case CHANNEL_NOISE_AB:       // generator sumu na kanalu A, B
          x &= ~((1 << 3) | (1 << 4));
          break;

        case CHANNEL_NOISE_AC:       // generator sumu na kanalu A, C
          x &= ~((1 << 3) | (1 << 5));
          break;

        case CHANNEL_NOISE_BC:       // generator sumu na kanalu B, C
          x &= ~((1 << 4) | (1 << 5));
          break;

        case CHANNEL_NOISE_ABC:       // generator sumu na kanalu A, B, C
          x &= ~((1 << 3) | (1 << 4) | (1 << 5));
          break;
      }
    }
  }
  zapis_do_registru(ENABLE_NOISE_TONE, x);  // zapis vybranych kanalu do registru
}

void nastaveni_frekvence_tonu(kanaly_ton channel, uint32_t frekvence)
{
#ifdef CLOCK_1MHZ
  if((frekvence >= 16) && (frekvence <= 62500)) // limitni frekvence ktere lze generovat pri 1 MHz CLK
#endif

#ifdef CLOCK_2MHZ
    if((frekvence >= 31) && (frekvence <= 125000))  // limitni frekvence ktere lze generovat pri 2 MHz CLK
#endif
    {
      uint32_t coarse_hodnota = 0;          // promenna pro ulozeni hodnoty registru R1, R3 a R5
      uint32_t fine_hodnota = 0;            // promenna pro ulozeni hodnoty registru R0, R2 a R4

#ifdef CLOCK_1MHZ
      uint16_t x = 1E6 / (frekvence << 4);   // vypocet pro CLK 1 MHz
#endif

#ifdef CLOCK_2MHZ

/*#define N_DECIMAL_POINTS_PRECISION (1000) // n = 3. Three decimal points.


float f = 2E6 / (frekvence *256);
uint32_t x = (uint32_tint)f;
uint32_t decimalPart = ((uint32_t)(f*N_DECIMAL_POINTS_PRECISION)%N_DECIMAL_POINTS_PRECISION);
       */

      uint32_t x = 2E6 / (frekvence << 4);  // vypocet pro CLK 2 MHz
#endif

      if(x >= 256)    // pokud je hodnota po deleni vetsi nez 255, tak se provede rozdeleni do dvou registru
      {
        coarse_hodnota = x >> 8;  // vznik hodnoty pro registr R1, R3 a R5
        fine_hodnota = x & 0x0FF; // vznik hodnoty pro registr R0, R2 a R4
      }
      else
      {
        fine_hodnota = x & 0x0FF; // kdy hodnota po deleni neni vetsi nez 255, tak se pouzije jen jeden registr
      }

      switch(channel)             // vyber kanalu na kterem bude zadana frekvence
      {
        case CHANNEL_TONE_NONE:
          break;

        case CHANNEL_TONE_A:
        {
          zapis_do_registru(CHANNEL_A_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_A_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_B:
        {
          zapis_do_registru(CHANNEL_B_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_C:
        {
          zapis_do_registru(CHANNEL_C_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_AB:
        {
          zapis_do_registru(CHANNEL_A_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_A_TONE_FINE, fine_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_AC:
        {
          zapis_do_registru(CHANNEL_A_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_A_TONE_FINE, fine_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_BC:
        {
          zapis_do_registru(CHANNEL_B_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_FINE, fine_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_FINE, fine_hodnota);
        }
        break;

        case CHANNEL_TONE_ABC:
        {
          zapis_do_registru(CHANNEL_A_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_A_TONE_FINE, fine_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_B_TONE_FINE, fine_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_COARSE, coarse_hodnota);
          zapis_do_registru(CHANNEL_C_TONE_FINE, fine_hodnota);
        }
        break;
      }
    }
}

void nastaveni_amplitudy_kanalu(kanaly_ton channel, uint8_t amplituda, envelope povolit_envelope)
{
  if(amplituda >= 16)     // ochrana proti zadani vetsi hodnoty amplitudy
  {
    return;
  }

  if(povolit_envelope)    // kdyz chceme povolit obalkovy generator
  {
    amplituda = 1 << 4;   // posun pro aktivaci generatoru
  }

  switch(channel)         // vyber kanalu
  {
    case CHANNEL_TONE_NONE:
    {
      zapis_do_registru(CHANNEL_A_AMPLITUDE, 0);
      zapis_do_registru(CHANNEL_B_AMPLITUDE, 0);
      zapis_do_registru(CHANNEL_C_AMPLITUDE, 0);
    }
    break;

    case CHANNEL_TONE_A:
    {
      zapis_do_registru(CHANNEL_A_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_B:
    {
      zapis_do_registru(CHANNEL_B_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_C:
    {
      zapis_do_registru(CHANNEL_C_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_AB:
    {
      zapis_do_registru(CHANNEL_A_AMPLITUDE, amplituda);
      zapis_do_registru(CHANNEL_B_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_AC:
    {
      zapis_do_registru(CHANNEL_A_AMPLITUDE, amplituda);
      zapis_do_registru(CHANNEL_C_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_BC:
    {
      zapis_do_registru(CHANNEL_B_AMPLITUDE, amplituda);
      zapis_do_registru(CHANNEL_C_AMPLITUDE, amplituda);
    }
    break;

    case CHANNEL_TONE_ABC:
    {
      zapis_do_registru(CHANNEL_A_AMPLITUDE, amplituda);
      zapis_do_registru(CHANNEL_B_AMPLITUDE, amplituda);
      zapis_do_registru(CHANNEL_C_AMPLITUDE, amplituda);
    }
    break;
  }
}

void nastaveni_frekvence_noise_generatoru(uint32_t frekvence)
{
#ifdef CLOCK_1MHZ
  if((frekvence >= 2016) && (frekvence <= 62500))   // limitni frekvence ktere lze generovat pri 1 MHz CLK
  {
    uint8_t x = 1E6 / (frekvence << 4);             // vypocet pro CLK 1 MHz
    zapis_do_registru(NOISE_PERIOD, x);             // zapis frekvence do registru
  }

#endif

#ifdef CLOCK_2MHZ

  if((frekvence >= 4032) && (frekvence <= 125000))  // limitni frekvence ktere lze generovat pri 2 MHz CLK
  {
    uint8_t x = 2E6 / (frekvence << 4);             // vypocet pro CLK 2 MHz
    zapis_do_registru(NOISE_PERIOD, x);             // zapis frekvence do registru
  }
#endif
}

void nastaveni_frekvence_tvaru_obalky(float frekvence, obalky tvar_obalky)
{

#ifdef CLOCK_1MHZ
  if((frekvence >= 0.06) && (frekvence <= 3905))   // limitni frekvence ktere lze generovat pri 1 MHz CLK
#endif

#ifdef CLOCK_2MHZ
    if((frekvence >= 0.13) && (frekvence <= 7812))  // limitni frekvence ktere lze generovat pri 2 MHz CLK
#endif
    {
      uint16_t coarse_hodnota = 0;                // promenna pro ulozeni hodnoty registru R12
      uint16_t fine_hodnota = 0;                  // promenna pro ulozeni hodnoty registru R11
      uint16_t x = 0;

#ifdef CLOCK_1MHZ
      x = 1E6 / (frekvence * 256);              // vypocet pro CLK 1 MHz
#endif

#ifdef CLOCK_2MHZ
      x = 2E6 / (frekvence * 256);              // vypocet pro CLK 2 MHz
#endif

      if(x >= 256)  // pokud je hodnota po deleni vetsi nez 255, tak se provede rozdeleni do dvou registru
      {
        coarse_hodnota = x >> 8;            // vznik hodnoty pro registr R12
        fine_hodnota = x & 0x00FF;          // vznik hodnoty pro registr R11
      }
      else
      {
        fine_hodnota = x & 0x00FF;        // kdy hodnota po deleni neni vetsi nez 255, tak se pouzije jen jeden registr
      }

      zapis_do_registru(ENVELOPE_PERIOD_COARSE, coarse_hodnota);  // zapis do registru R12
      zapis_do_registru(ENVELOPE_PERIOD_FINE, fine_hodnota);      // zapis do registru R11

      switch(tvar_obalky)           // vyber tvaru obalky
      {
        case rampa_z_1_do_0:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0);
          break;

        case trojuhelnikovy_pulz_z_0_do_0:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0x4);
          break;

        case trojuhelnik_z_1_do_0:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0x8);
          break;

        case pila_z_1:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0xA);
          break;

        case trojuhelnikovy_pulz_z_1_do_1:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0xB);
          break;

        case trojuhelnik_z_0_do_1:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0xC);
          break;

        case rampa_z_0_do_1:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0xD);
          break;

        case pila_z_0:
          zapis_do_registru(ENVELOPE_SHAPE_CYCLE, 0xE);
          break;
      }
    }
}

volatile uint32_t _ticks = 0;   // promenna pro casovac SysTick

void SysTick_Handler(void)
{
  _ticks++;                   // inkrementace promenne po preteceni casovace
}

void delay_ms(uint32_t cas)
{
  _ticks = 0;               // nastaveni na nulu po kazdem pruchodu funkci
  while(_ticks < cas)       // kdyz je zadany pocet _ticks mensi nez zadany cas, tak funkce ceka
    ;
}
